/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20180427 (64-bit version)(RM)
 * Copyright (c) 2000 - 2018 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-2-CNL-ULT.aml, Wed Jul 24 15:15:13 2019
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000009DC (2524)
 *     Revision         0x01
 *     Checksum         0x52
 *     OEM ID           "HUAWEI"
 *     OEM Table ID     "CNL-ULT"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "ACPI"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("", "SSDT", 1, "HUAWEI", "CNL-ULT", 0x00001000)
{
    External (_SB_.PCI0.LPCB.H_EC.WMEN, UnknownObj)    // (from opcode)
    External (GBTT, MethodObj)    // 1 Arguments (from opcode)
    External (GCPL, MethodObj)    // 1 Arguments (from opcode)
    External (GCVA, MethodObj)    // 1 Arguments (from opcode)
    External (GEEP, MethodObj)    // 1 Arguments (from opcode)
    External (GFNS, MethodObj)    // 1 Arguments (from opcode)
    External (GFRQ, MethodObj)    // 1 Arguments (from opcode)
    External (GFRS, MethodObj)    // 1 Arguments (from opcode)
    External (GGDS, MethodObj)    // 1 Arguments (from opcode)
    External (GHWP, MethodObj)    // 1 Arguments (from opcode)
    External (GLIV, MethodObj)    // 1 Arguments (from opcode)
    External (GODP, MethodObj)    // 1 Arguments (from opcode)
    External (GPCI, MethodObj)    // 1 Arguments (from opcode)
    External (GPSI, MethodObj)    // 1 Arguments (from opcode)
    External (GSTP, MethodObj)    // 1 Arguments (from opcode)
    External (GTDP, MethodObj)    // 1 Arguments (from opcode)
    External (GTMP, MethodObj)    // 1 Arguments (from opcode)
    External (GTSI, MethodObj)    // 1 Arguments (from opcode)
    External (GVER, MethodObj)    // 1 Arguments (from opcode)
    External (PAFF, MethodObj)    // 1 Arguments (from opcode)
    External (PAFS, MethodObj)    // 1 Arguments (from opcode)
    External (RDTB, MethodObj)    // 1 Arguments (from opcode)
    External (RPDT, MethodObj)    // 1 Arguments (from opcode)
    External (RPPT, MethodObj)    // 1 Arguments (from opcode)
    External (SBTT, MethodObj)    // 1 Arguments (from opcode)
    External (SCRP, MethodObj)    // 1 Arguments (from opcode)
    External (SEEP, MethodObj)    // 1 Arguments (from opcode)
    External (SFRS, MethodObj)    // 1 Arguments (from opcode)
    External (SHWP, MethodObj)    // 1 Arguments (from opcode)
    External (SLIV, MethodObj)    // 1 Arguments (from opcode)
    External (SMLS, MethodObj)    // 1 Arguments (from opcode)
    External (SODP, MethodObj)    // 1 Arguments (from opcode)
    External (SPDT, MethodObj)    // 1 Arguments (from opcode)
    External (SPLV, MethodObj)    // 1 Arguments (from opcode)
    External (SPSL, MethodObj)    // 1 Arguments (from opcode)
    External (STDP, MethodObj)    // 1 Arguments (from opcode)
    External (STMT, MethodObj)    // 1 Arguments (from opcode)
    External (STSL, MethodObj)    // 1 Arguments (from opcode)
    External (STTB, MethodObj)    // 1 Arguments (from opcode)

    OperationRegion (ONVS, SystemMemory, 0x6FC45000, 0x00000108)
    Field (ONVS, AnyAcc, NoLock, Preserve)
    {
        INPT,   64, 
        OUPT,   2048
    }

    Scope (\_SB)
    {
        Mutex (MUTW, 0x00)
        Device (AMW0)
        {
            Name (_HID, EisaId ("PNP0C14"))  // _HID: Hardware ID
            Name (_UID, "HWMI")  // _UID: Unique ID
            Name (_WDG, Buffer (0x3C)
            {
                /* 0000 */  0x5B, 0x0F, 0xBC, 0xAB, 0xA1, 0x8E, 0xD1, 0x11,
                /* 0008 */  0xA0, 0x00, 0xC9, 0x06, 0x29, 0x10, 0x00, 0x00,
                /* 0010 */  0x41, 0x41, 0x01, 0x02, 0x5C, 0x0F, 0xBC, 0xAB,
                /* 0018 */  0xA1, 0x8E, 0xD1, 0x11, 0xA0, 0x00, 0xC9, 0x06,
                /* 0020 */  0x29, 0x10, 0x00, 0x00, 0xA0, 0x00, 0x01, 0x08,
                /* 0028 */  0x21, 0x12, 0x90, 0x05, 0x66, 0xD5, 0xD1, 0x11,
                /* 0030 */  0xB2, 0xF0, 0x00, 0xA0, 0xC9, 0x06, 0x29, 0x10,
                /* 0038 */  0x42, 0x41, 0x01, 0x00                         
            })
            Name (WQBA, Buffer (0x03EB)
            {
                /* 0000 */  0x46, 0x4F, 0x4D, 0x42, 0x01, 0x00, 0x00, 0x00,
                /* 0008 */  0xDB, 0x03, 0x00, 0x00, 0x20, 0x0C, 0x00, 0x00,
                /* 0010 */  0x44, 0x53, 0x00, 0x01, 0x1A, 0x7D, 0xDA, 0x54,
                /* 0018 */  0x18, 0xCD, 0x85, 0x00, 0x01, 0x06, 0x18, 0x42,
                /* 0020 */  0x10, 0x05, 0x10, 0x92, 0xE2, 0x81, 0x42, 0x04,
                /* 0028 */  0x8A, 0x40, 0x24, 0x69, 0x0E, 0x60, 0x30, 0x1A,
                /* 0030 */  0x40, 0x24, 0x09, 0x42, 0xBC, 0x22, 0x20, 0x42,
                /* 0038 */  0x20, 0x24, 0x51, 0x80, 0x79, 0x01, 0xBA, 0x05,
                /* 0040 */  0x18, 0x16, 0x60, 0x5B, 0x80, 0x69, 0x01, 0x8E,
                /* 0048 */  0x81, 0xD4, 0xBF, 0x3F, 0xB4, 0x40, 0x24, 0x02,
                /* 0050 */  0x92, 0x4A, 0x81, 0x90, 0x50, 0x01, 0xCA, 0x05,
                /* 0058 */  0xF8, 0x16, 0xA0, 0x1D, 0x51, 0x92, 0x05, 0x58,
                /* 0060 */  0x86, 0x11, 0x81, 0xBD, 0x0A, 0xB0, 0x29, 0xC0,
                /* 0068 */  0x24, 0x1A, 0x82, 0xA0, 0x9C, 0x61, 0xA0, 0xE0,
                /* 0070 */  0x0D, 0xC8, 0x06, 0xC1, 0x44, 0x0F, 0x02, 0x25,
                /* 0078 */  0x66, 0x34, 0x64, 0x06, 0x9D, 0xCF, 0x45, 0xF0,
                /* 0080 */  0x27, 0x51, 0xB8, 0x00, 0xE9, 0x18, 0x1A, 0xC1,
                /* 0088 */  0x11, 0x25, 0xE8, 0x70, 0x48, 0x92, 0x8D, 0x20,
                /* 0090 */  0x41, 0x02, 0x14, 0xC2, 0xCB, 0xA7, 0x00, 0xA7,
                /* 0098 */  0x28, 0xD2, 0x28, 0xC0, 0x3A, 0x9C, 0x60, 0x63,
                /* 00A0 */  0x72, 0xA4, 0x28, 0x07, 0x71, 0x36, 0x06, 0xEB,
                /* 00A8 */  0x19, 0x45, 0x40, 0xA7, 0xC2, 0x09, 0xA2, 0x1F,
                /* 00B0 */  0x0A, 0x46, 0x06, 0x84, 0x3C, 0x0A, 0xB0, 0x8A,
                /* 00B8 */  0xA6, 0xB9, 0x24, 0xB0, 0x7B, 0x01, 0x06, 0x67,
                /* 00C0 */  0x21, 0x84, 0x23, 0x29, 0x4C, 0x80, 0x66, 0x01,
                /* 00C8 */  0xD6, 0x04, 0x28, 0x16, 0x60, 0x4B, 0x80, 0xB8,
                /* 00D0 */  0x21, 0x69, 0x32, 0x8D, 0xA1, 0x08, 0x22, 0xC2,
                /* 00D8 */  0x71, 0x46, 0x31, 0x66, 0xC0, 0x08, 0x46, 0x39,
                /* 00E0 */  0x9A, 0xE6, 0x40, 0xA4, 0x4D, 0x80, 0x32, 0x10,
                /* 00E8 */  0xA1, 0xC5, 0x62, 0x08, 0xB6, 0x3F, 0x08, 0x32,
                /* 00F0 */  0x72, 0xDC, 0x11, 0xC0, 0xE3, 0x39, 0xA9, 0xC8,
                /* 00F8 */  0x07, 0xE8, 0x51, 0x24, 0xF0, 0xA8, 0xCE, 0xAF,
                /* 0100 */  0x5C, 0x5C, 0x89, 0x47, 0x15, 0xC6, 0x09, 0x24,
                /* 0108 */  0x70, 0xB0, 0x13, 0x81, 0x24, 0x80, 0x28, 0x12,
                /* 0110 */  0x3C, 0x6A, 0xE0, 0x09, 0x8E, 0xDF, 0x43, 0x3B,
                /* 0118 */  0xCE, 0xA3, 0x3E, 0xCE, 0x13, 0x38, 0x57, 0x8F,
                /* 0120 */  0xA0, 0xCE, 0x53, 0x01, 0x19, 0x03, 0xC3, 0x4A,
                /* 0128 */  0xF0, 0x87, 0xE0, 0x93, 0x00, 0xDE, 0x35, 0xA0,
                /* 0130 */  0xFE, 0xFF, 0xF7, 0x83, 0x27, 0x01, 0x36, 0xE4,
                /* 0138 */  0x70, 0x98, 0xF1, 0x7A, 0xE2, 0xC7, 0xE9, 0x51,
                /* 0140 */  0x1E, 0x09, 0x83, 0x38, 0xA2, 0x83, 0xC3, 0x0E,
                /* 0148 */  0xF9, 0x64, 0x8E, 0xAC, 0x54, 0x01, 0x66, 0x4F,
                /* 0150 */  0x08, 0xB2, 0x08, 0xA4, 0xF1, 0xF8, 0x50, 0xE0,
                /* 0158 */  0xF9, 0xBC, 0x05, 0x24, 0xB0, 0xFC, 0x41, 0xA0,
                /* 0160 */  0x46, 0x66, 0x68, 0x8F, 0xFB, 0x91, 0x80, 0x1D,
                /* 0168 */  0x16, 0x0E, 0x8B, 0x89, 0x3D, 0x4C, 0xD0, 0xF1,
                /* 0170 */  0x80, 0xFF, 0x56, 0x70, 0xFC, 0x11, 0x4E, 0xDF,
                /* 0178 */  0xF3, 0x35, 0x41, 0x81, 0xC0, 0xE8, 0x01, 0xD9,
                /* 0180 */  0xAF, 0x00, 0x84, 0xE0, 0x65, 0x8E, 0x48, 0xC7,
                /* 0188 */  0x80, 0x08, 0x09, 0xDE, 0x1B, 0xE2, 0x1E, 0xF8,
                /* 0190 */  0xF3, 0x02, 0x83, 0x08, 0xF3, 0xD6, 0xE0, 0x11,
                /* 0198 */  0x1C, 0x0D, 0x13, 0x79, 0x98, 0x40, 0x0F, 0x80,
                /* 01A0 */  0x9F, 0x02, 0xE2, 0x87, 0x3D, 0x99, 0x03, 0x38,
                /* 01A8 */  0x9C, 0x28, 0xE7, 0x70, 0x3C, 0xBE, 0x42, 0x18,
                /* 01B0 */  0x21, 0xFE, 0xB3, 0xC1, 0x73, 0x86, 0xAF, 0x0D,
                /* 01B8 */  0x27, 0xF4, 0x18, 0x71, 0x4A, 0x2F, 0x03, 0x26,
                /* 01C0 */  0x18, 0xF3, 0x35, 0xA0, 0x53, 0x88, 0x23, 0x82,
                /* 01C8 */  0xC8, 0xC6, 0x4A, 0x7D, 0xE8, 0xA0, 0x11, 0x57,
                /* 01D0 */  0xAB, 0x01, 0xE1, 0xB0, 0x9F, 0x2C, 0x7C, 0x50,
                /* 01D8 */  0x10, 0x98, 0x4E, 0x24, 0x3C, 0x12, 0x85, 0x82,
                /* 01E0 */  0x8F, 0x87, 0x82, 0x3B, 0xEA, 0xC1, 0x84, 0x82,
                /* 01E8 */  0x18, 0xD0, 0x39, 0x20, 0x64, 0xE5, 0x20, 0x80,
                /* 01F0 */  0x52, 0x02, 0xA2, 0x19, 0xBC, 0x4B, 0xBC, 0x3B,
                /* 01F8 */  0xBC, 0x32, 0xF8, 0xD6, 0x11, 0xE6, 0x88, 0x7C,
                /* 0200 */  0xFD, 0xF0, 0x75, 0xC1, 0x33, 0xF4, 0x45, 0x80,
                /* 0208 */  0xDF, 0x50, 0x7C, 0x34, 0x30, 0xB8, 0xD5, 0x08,
                /* 0210 */  0xF8, 0xFF, 0x03, 0x32, 0x30, 0x7E, 0xD7, 0xE0,
                /* 0218 */  0x04, 0x75, 0x9D, 0x06, 0xA0, 0x0F, 0xE4, 0x08,
                /* 0220 */  0x3C, 0x92, 0x93, 0x31, 0x41, 0x7D, 0x97, 0x01,
                /* 0228 */  0x50, 0x00, 0x79, 0xF8, 0x56, 0x7A, 0x03, 0xA0,
                /* 0230 */  0x63, 0x08, 0x11, 0x26, 0x9A, 0xD1, 0xF9, 0x41,
                /* 0238 */  0xC3, 0x83, 0xE5, 0x51, 0x60, 0x34, 0x58, 0x83,
                /* 0240 */  0x78, 0x62, 0x8E, 0x03, 0x21, 0x27, 0x83, 0x45,
                /* 0248 */  0x4D, 0xD2, 0x23, 0xEA, 0xEC, 0x1E, 0xA2, 0x11,
                /* 0250 */  0xBC, 0xB3, 0xF8, 0x48, 0xF0, 0x16, 0xE1, 0x03,
                /* 0258 */  0x02, 0x9B, 0xEF, 0xC3, 0x06, 0xAC, 0xD3, 0x8A,
                /* 0260 */  0x67, 0xED, 0x89, 0x18, 0xCE, 0xD3, 0xE5, 0x70,
                /* 0268 */  0x9E, 0x2E, 0x1F, 0x8D, 0x0F, 0x13, 0xF0, 0xC7,
                /* 0270 */  0xCB, 0xE7, 0xE3, 0xE1, 0x11, 0x08, 0x19, 0x39,
                /* 0278 */  0x28, 0xD0, 0x71, 0xF9, 0xA4, 0x60, 0xC8, 0xF7,
                /* 0280 */  0x96, 0x27, 0x85, 0x83, 0xF1, 0x99, 0x80, 0x13,
                /* 0288 */  0x0C, 0x01, 0xA1, 0x03, 0x8A, 0x87, 0x05, 0xAE,
                /* 0290 */  0xE1, 0x9C, 0xFB, 0xA3, 0x87, 0x97, 0xE5, 0xD1,
                /* 0298 */  0xC1, 0x3B, 0x34, 0x58, 0xD6, 0xE8, 0x40, 0x33,
                /* 02A0 */  0xAB, 0x07, 0x0F, 0xEC, 0xFF, 0xFF, 0x6E, 0x00,
                /* 02A8 */  0x46, 0x78, 0x4C, 0x6C, 0x08, 0x59, 0x18, 0x0F,
                /* 02B0 */  0x1D, 0x16, 0x3F, 0x16, 0xF8, 0x96, 0xF1, 0xCE,
                /* 02B8 */  0xE4, 0x5B, 0x08, 0x6E, 0x4C, 0xAF, 0x05, 0x3E,
                /* 02C0 */  0x07, 0x18, 0xD6, 0xE3, 0xE5, 0xB0, 0x46, 0x0B,
                /* 02C8 */  0x7B, 0xE2, 0xCF, 0x27, 0xBE, 0xDB, 0x78, 0x62,
                /* 02D0 */  0xBE, 0x21, 0xB0, 0x53, 0x0D, 0x38, 0x00, 0xF1,
                /* 02D8 */  0xDE, 0x2F, 0x34, 0x64, 0x02, 0x06, 0x64, 0x73,
                /* 02E0 */  0x7C, 0x7C, 0x02, 0xCB, 0xD1, 0xE0, 0x38, 0xCF,
                /* 02E8 */  0xED, 0x95, 0x89, 0x9F, 0x9E, 0x60, 0x10, 0x38,
                /* 02F0 */  0xC6, 0xF3, 0xC0, 0x20, 0x5E, 0xA1, 0x84, 0xC3,
                /* 02F8 */  0xA0, 0x4E, 0x5D, 0xC0, 0xFB, 0xA4, 0xE1, 0x71,
                /* 0300 */  0x82, 0x63, 0x9A, 0x8F, 0x1D, 0x3E, 0x06, 0x78,
                /* 0308 */  0x98, 0xAF, 0x45, 0x51, 0x3C, 0x17, 0x8F, 0xEB,
                /* 0310 */  0x51, 0x80, 0x41, 0xFD, 0xFF, 0x8F, 0xFE, 0xC5,
                /* 0318 */  0x20, 0x96, 0x51, 0xCE, 0x2D, 0xD6, 0x01, 0xC4,
                /* 0320 */  0x79, 0x74, 0x30, 0x52, 0xA0, 0x20, 0x07, 0x11,
                /* 0328 */  0x23, 0x90, 0xCF, 0x15, 0x3E, 0x77, 0x81, 0x6B,
                /* 0330 */  0x06, 0xCF, 0x5D, 0xC0, 0x38, 0xF2, 0x8B, 0x43,
                /* 0338 */  0x67, 0x02, 0x9F, 0xBB, 0x00, 0x7E, 0x44, 0x3F,
                /* 0340 */  0x02, 0xA1, 0xFF, 0xFF, 0xA3, 0xF0, 0x61, 0x23,
                /* 0348 */  0xE2, 0x61, 0x9C, 0xB6, 0x0F, 0x52, 0x6C, 0xD0,
                /* 0350 */  0x16, 0x75, 0x4A, 0x41, 0x1D, 0x2E, 0x7C, 0x4A,
                /* 0358 */  0x61, 0x87, 0x85, 0xD7, 0x07, 0x43, 0x3C, 0xA4,
                /* 0360 */  0x60, 0x0E, 0x00, 0x3E, 0x52, 0x80, 0x63, 0x24,
                /* 0368 */  0x98, 0xD3, 0x84, 0x4F, 0x11, 0x3E, 0x0F, 0xFA,
                /* 0370 */  0x3E, 0xE1, 0x93, 0x87, 0x61, 0x8C, 0x64, 0x3C,
                /* 0378 */  0x1F, 0x29, 0xF0, 0x90, 0x81, 0x5E, 0x29, 0x70,
                /* 0380 */  0x07, 0x23, 0x30, 0xCA, 0x3B, 0xB4, 0x81, 0xEE,
                /* 0388 */  0xF4, 0x81, 0x39, 0xB3, 0x01, 0x93, 0xAB, 0x87,
                /* 0390 */  0x87, 0xC0, 0xCF, 0x12, 0x1E, 0x02, 0x1F, 0xC0,
                /* 0398 */  0x23, 0xC8, 0xD9, 0xF9, 0x1C, 0x74, 0x4E, 0xB8,
                /* 03A0 */  0xB3, 0x0A, 0x9F, 0x12, 0x6E, 0x00, 0x18, 0x85,
                /* 03A8 */  0x36, 0x7D, 0x6A, 0x34, 0x6A, 0xD5, 0xA0, 0x4C,
                /* 03B0 */  0x8D, 0x32, 0x0D, 0x6A, 0xF5, 0xA9, 0xD4, 0x98,
                /* 03B8 */  0xB1, 0x83, 0x83, 0x45, 0xBD, 0x1D, 0x74, 0x38,
                /* 03C0 */  0xF0, 0xF1, 0xCD, 0x20, 0xCE, 0x4F, 0x21, 0x23,
                /* 03C8 */  0xA3, 0xF3, 0xD9, 0x46, 0x40, 0x0E, 0x0F, 0x22,
                /* 03D0 */  0x20, 0x4B, 0x79, 0x1C, 0x09, 0xC8, 0xB1, 0x40,
                /* 03D8 */  0x04, 0xE4, 0xFF, 0x7F, 0x48, 0x20, 0x2A, 0xD1,
                /* 03E0 */  0x04, 0x08, 0x0B, 0x08, 0x42, 0xA3, 0xA9, 0x00,
                /* 03E8 */  0x61, 0xFF, 0x7F                               
            })
            Method (WMAA, 3, Serialized)
            {
                Acquire (MUTW, 0xFFFF)
                Name (RTBF, Package (0x02)
                {
                    Buffer (0x04){}, 
                    Buffer (0x0100){}
                })
                CreateByteField (Arg2, Zero, MFUN)
                CreateByteField (Arg2, One, SFUN)
                Store (DerefOf (Index (RTBF, One)), Local0)
                CreateByteField (Local0, Zero, STAT)
                Store (One, STAT)
                Switch (MFUN)
                {
                    Case (One)
                    {
                        Switch (SFUN)
                        {
                            Case (One)
                            {
                                Store (GVER (Arg2), Local0)
                            }

                        }
                    }
                    Case (0x02)
                    {
                        Switch (SFUN)
                        {
                            Case (One)
                            {
                                Store (GTSI (Arg2), Local0)
                            }
                            Case (0x02)
                            {
                                Store (GTMP (Arg2), Local0)
                            }
                            Case (0x03)
                            {
                                Store (STMT (Arg2), Local0)
                            }
                            Case (0x04)
                            {
                                Store (GPSI (Arg2), Local0)
                            }
                            Case (0x05)
                            {
                                Store (GPCI (Arg2), Local0)
                            }
                            Case (0x06)
                            {
                                Store (GLIV (Arg2), Local0)
                            }
                            Case (0x07)
                            {
                                Store (SLIV (Arg2), Local0)
                            }
                            Case (0x08)
                            {
                                Store (GFNS (Arg2), Local0)
                            }
                            Case (0x09)
                            {
                                Store (GCVA (Arg2), Local0)
                            }
                            Case (0x0A)
                            {
                                Store (GFRQ (Arg2), Local0)
                            }

                        }
                    }
                    Case (0x03)
                    {
                        Switch (SFUN)
                        {
                            Case (One)
                            {
                                Store (SPSL (Arg2), Local0)
                            }
                            Case (0x02)
                            {
                                Store (RDTB (Arg2), Local0)
                            }
                            Case (0x03)
                            {
                                Store (STTB (Arg2), Local0)
                            }
                            Case (0x04)
                            {
                                Store (GHWP (Arg2), Local0)
                            }
                            Case (0x05)
                            {
                                Store (SHWP (Arg2), Local0)
                            }
                            Case (0x06)
                            {
                                Store (GEEP (Arg2), Local0)
                            }
                            Case (0x07)
                            {
                                Store (SEEP (Arg2), Local0)
                            }
                            Case (0x08)
                            {
                                Store (GTDP (Arg2), Local0)
                            }
                            Case (0x09)
                            {
                                Store (STDP (Arg2), Local0)
                            }
                            Case (0x0C)
                            {
                                Store (GCPL (Arg2), Local0)
                            }
                            Case (0x0D)
                            {
                                Store (SPLV (Arg2), Local0)
                            }
                            Case (0x0E)
                            {
                                Store (GODP (Arg2), Local0)
                            }
                            Case (0x0F)
                            {
                                Store (SODP (Arg2), Local0)
                            }
                            Case (0x10)
                            {
                                Store (SBTT (Arg2), Local0)
                            }
                            Case (0x11)
                            {
                                Store (GBTT (Arg2), Local0)
                            }

                        }
                    }
                    Case (0x04)
                    {
                        Switch (SFUN)
                        {
                            Case (One)
                            {
                                Store (STSL (Arg2), Local0)
                            }
                            Case (0x02)
                            {
                                Store (GGDS (Arg2), Local0)
                            }
                            Case (0x03)
                            {
                                Store (SCRP (Arg2), Local0)
                            }
                            Case (0x04)
                            {
                                Store (PAFS (Arg2), Local0)
                            }
                            Case (0x05)
                            {
                                Store (PAFF (Arg2), Local0)
                            }
                            Case (0x06)
                            {
                                Store (GFRS (Arg2), Local0)
                            }
                            Case (0x07)
                            {
                                Store (SFRS (Arg2), Local0)
                            }
                            Case (0x08)
                            {
                                Store (SPDT (Arg2), Local0)
                            }
                            Case (0x09)
                            {
                                Store (RPDT (Arg2), Local0)
                            }
                            Case (0x0A)
                            {
                                Store (RPPT (Arg2), Local0)
                            }
                            Case (0x0B)
                            {
                                Store (SMLS (Arg2), Local0)
                            }

                        }
                    }
                    Case (0x05)
                    {
                        Switch (SFUN)
                        {
                            Case (One)
                            {
                                Store (GSTP (Arg2), Local0)
                            }

                        }
                    }

                }

                Store (Local0, Index (RTBF, One))
                Release (MUTW)
                Return (RTBF)
            }

            Method (_WED, 1, NotSerialized)  // _Wxx: Wake Event
            {
                Return (\_SB.PCI0.LPCB.H_EC.WMEN)
            }
        }
    }
}

